diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index 844eecd9f..2b4620b52 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -53,7 +53,6 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
         if (block == null || !(block.getLogic() instanceof BlockLogicSign sign))
             return; // Check to make sure the block for the entity is present before rendering, some edge cases have the tile entity loaded before the block data and can cause a crash
 
-//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         GLRenderer.pushFrame();
 
         final StaticEntityModel model;
@@ -101,7 +100,6 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
         GLRenderer.pushFrame();
         GLRenderer.enableState(State.BLEND);
         GLRenderer.modelM4f().translate(0 * scale, height * scale, 1.05f * scale);
-//        GL11.glNormal3f(0, 0, 1);
         GLRenderer.setDepthMask(false);
         GLRenderer.setColor4f(1, 1, 1, 1);
         final EnumSignPicture picture = tileEntity.getPicture();
@@ -164,7 +162,6 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
         GLRenderer.setDepthMask(true);
         GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         GLRenderer.popFrame();
-//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
 
     private static void drawTexturedModalRect(final double width, final double height, final int color, final @NotNull IconCoordinate coordinate) {
@@ -234,35 +231,10 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
             this.referenceEntry.line4 = line4.toString();
             this.referenceEntry.config = config;
 
-//            MeshEntry entry = null;
-//            final int size = this.bufferedMeshes.size();
-//            for (int i = 0; i < size; i++) {
-//                final MeshEntry e = this.bufferedMeshes.get(i);
-//                if (this.referenceEntry.equals(e)) {
-//                    entry = e;
-//                    break;
-//                }
-//            }
-
-//            if (entry != null) {
-//                entry.lastUse = System.currentTimeMillis();
-//                GL11.glCallList(entry.list);
-//            } else {
-//                entry = new MeshEntry(line1, line2, line3, line4, config);
-//                entry.lastUse = System.currentTimeMillis();
-//                entry.list = getDisplayList();
-//
-//                GL11.glNewList(entry.list, GL11.GL_COMPILE);
-                sr.render(line1, -sr.stringWidth(line1) / 2, 0).setConfig(config).call();
-                sr.render(line2, -sr.stringWidth(line2) / 2, 10).setConfig(config).call();
-                sr.render(line3, -sr.stringWidth(line3) / 2, 20).setConfig(config).call();
-                sr.render(line4, -sr.stringWidth(line4) / 2, 30).setConfig(config).call();
-//                GL11.glEndList();
-//                GL11.glCallList(entry.list);
-//
-//                this.bufferedMeshes.add(entry);
-//            }
-
+            sr.render(line1, -sr.stringWidth(line1) / 2, 0).setConfig(config).call();
+            sr.render(line2, -sr.stringWidth(line2) / 2, 10).setConfig(config).call();
+            sr.render(line3, -sr.stringWidth(line3) / 2, 20).setConfig(config).call();
+            sr.render(line4, -sr.stringWidth(line4) / 2, 30).setConfig(config).call();
         }
 
         public static class MeshEntry {
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
index 822ba11e4..79374338e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
@@ -58,7 +58,6 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
 
         final StaticEntityModel model = model(isPigman);
 
-//        GL12.glEnable(GL12.GL_RESCALE_NORMAL);
         GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         bindTexture(BLOCK_SKIN_MAP.getOrDefault(lowerBlock, BLOCK_SKIN_MAP.get(Blocks.STATUE_STONE_LOWER)));
         GLRenderer.pushFrame();
@@ -81,12 +80,10 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
 
         GLRenderer.enableState(State.CULL_FACE);
         GLRenderer.popFrame();
-//        GL12.glDisable(GL12.GL_RESCALE_NORMAL);
     }
 
     private void renderHeldItem(final @Nullable ItemStack itemStack, int lightmap, final boolean isPigman) {
         if (itemStack != null) {
-//            GL12.glEnable(GL12.GL_RESCALE_NORMAL);
             GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             model(isPigman).translateToBone("rightItem");
             GLRenderer.modelM4f().scale(-1, 1, 1);
@@ -94,7 +91,6 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
             ItemModelDispatcher.getInstance().getDispatch(itemStack).render(GLRenderer.getTessellator(), null, itemStack, DisplayPos.THIRD_PERSON_RIGHT_HAND, true, 1,
                lightmap, 1f, false);
             GLRenderer.enableState(State.CULL_FACE);
-//            GL12.glDisable(GL12.GL_RESCALE_NORMAL);
         }
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java b/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
index 54085a2b6..e973bd7e1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
+++ b/game/client/src/main/java/net/minecraft/client/render/window/GameWindowGLFW.java
@@ -37,8 +37,7 @@ import org.lwjgl.glfw.GLFWImage;
 import org.lwjgl.glfw.GLFWVidMode;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
-import org.lwjgl.opengl.Display;
-import org.lwjgl.opengl.GL;
+import org.lwjgl.opengl.*;
 
 import com.github.zarzelcow.legacylwjgl3.implementation.glfw.GLFWKeyboardImplementation;
 import com.github.zarzelcow.legacylwjgl3.implementation.glfw.GLFWMouseImplementation;
@@ -48,10 +47,6 @@ import com.github.zarzelcow.legacylwjgl3.implementation.input.InputImplementatio
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.PanelCrashReport;
 import net.minecraft.core.UnexpectedThrowable;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL43;
-import org.lwjgl.opengl.GLCapabilities;
-import org.lwjgl.opengl.GLDebugMessageCallback;
 import org.lwjgl.stb.STBImage;
 import org.lwjgl.system.MemoryStack;
 import org.lwjgl.system.MemoryUtil;
@@ -134,7 +129,7 @@ public class GameWindowGLFW implements GameWindow {
 
         if (capabilities.OpenGL43) {
             if (debug) {
-                GL11.glEnable(GL43.GL_DEBUG_OUTPUT);
+                GL41.glEnable(GL43.GL_DEBUG_OUTPUT);
                 this.glDebugMessageCallback = new OpenGLLoggerCallback();
                 GL43.glDebugMessageCallback(this.glDebugMessageCallback, NULL);
                 LOGGER.info("GL4.3 supported, enabling GL Error logging");
diff --git a/game/client/src/main/java/net/minecraft/client/util/debug/OpenGLLoggerCallback.java b/game/client/src/main/java/net/minecraft/client/util/debug/OpenGLLoggerCallback.java
index d5d174389..664f8ff47 100644
--- a/game/client/src/main/java/net/minecraft/client/util/debug/OpenGLLoggerCallback.java
+++ b/game/client/src/main/java/net/minecraft/client/util/debug/OpenGLLoggerCallback.java
@@ -4,7 +4,7 @@ import it.unimi.dsi.fastutil.ints.Int2BooleanMap;
 import it.unimi.dsi.fastutil.ints.Int2BooleanOpenHashMap;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.ARBFramebufferObject;
-import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL41;
 import org.lwjgl.opengl.GL43;
 import org.lwjgl.opengl.GLDebugMessageCallback;
 import org.lwjgl.system.MemoryUtil;
@@ -26,31 +26,31 @@ public class OpenGLLoggerCallback extends GLDebugMessageCallback {
         switch (severity) {
             case GL43.GL_DEBUG_SEVERITY_HIGH: {
                 LOGGER.error(
-                    "High Severity error from '{}' Type='{}' ErrorCode[{}]:",
+                    "High Severity error from '{}' Type='{}' ErrorCode[{}]: {}",
                     getSourceName(source),
                     getTypeName(type),
                     getIdName(id),
-                    new RuntimeException(msg)
+                    msg
                 );
                 break;
             }
             case GL43.GL_DEBUG_SEVERITY_MEDIUM: {
                 LOGGER.warn(
-                    "Medium Severity error from '{}' Type='{}' ErrorCode[{}]:",
+                    "Medium Severity error from '{}' Type='{}' ErrorCode[{}]: {}",
                     getSourceName(source),
                     getTypeName(type),
                     getIdName(id),
-                    new RuntimeException(msg)
+                    msg
                 );
                 break;
             }
             case GL43.GL_DEBUG_SEVERITY_LOW: {
                 LOGGER.warn(
-                    "Low Severity issue from '{}' Type='{}' ErrorCode[{}]:",
+                    "Low Severity issue from '{}' Type='{}' ErrorCode[{}]: {}",
                     getSourceName(source),
                     getTypeName(type),
                     getIdName(id),
-                    new RuntimeException(msg)
+                    msg
                 );
                 break;
             }
@@ -62,12 +62,12 @@ public class OpenGLLoggerCallback extends GLDebugMessageCallback {
 
     public @NotNull String getIdName(int error) {
         return switch (error) {
-            case GL11.GL_INVALID_ENUM -> "Invalid Enum";
-            case GL11.GL_INVALID_VALUE -> "Invalid Value";
-            case GL11.GL_INVALID_OPERATION -> "Invalid Operation";
-            case GL11.GL_STACK_OVERFLOW -> "Stack Overflow";
-            case GL11.GL_STACK_UNDERFLOW -> "Stack Underflow";
-            case GL11.GL_OUT_OF_MEMORY -> "Out of Memory";
+            case GL41.GL_INVALID_ENUM -> "Invalid Enum";
+            case GL41.GL_INVALID_VALUE -> "Invalid Value";
+            case GL41.GL_INVALID_OPERATION -> "Invalid Operation";
+            case GL41.GL_STACK_OVERFLOW -> "Stack Overflow";
+            case GL41.GL_STACK_UNDERFLOW -> "Stack Underflow";
+            case GL41.GL_OUT_OF_MEMORY -> "Out of Memory";
             case ARBFramebufferObject.GL_INVALID_FRAMEBUFFER_OPERATION -> "Invalid Framebuffer Operation";
             default -> "Unknown 0x" + Integer.toHexString(error);
         };
diff --git a/game/client/src/main/java/net/minecraft/client/util/helper/ScreenShot.java b/game/client/src/main/java/net/minecraft/client/util/helper/ScreenShot.java
index bccf69cf7..c26e31e08 100644
--- a/game/client/src/main/java/net/minecraft/client/util/helper/ScreenShot.java
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/ScreenShot.java
@@ -6,8 +6,8 @@ import java.text.SimpleDateFormat;
 import java.util.Date;
 
 import com.mojang.logging.LogUtils;
-import org.lwjgl.opengl.GL11;
 
+import org.lwjgl.opengl.GL41;
 import org.lwjgl.stb.STBImageWrite;
 import org.lwjgl.system.MemoryUtil;
 import org.slf4j.Logger;
@@ -34,9 +34,9 @@ public class ScreenShot
 
             var buffer1 = MemoryUtil.memCalloc(width * height * 3);
             var buffer2 = MemoryUtil.memCalloc(width * height * 3);
-            GL11.glPixelStorei(GL11.GL_PACK_ALIGNMENT, 1);
-            GL11.glPixelStorei(GL11.GL_UNPACK_ALIGNMENT, 1);
-            GL11.glReadPixels(0, 0, width, height, GL11.GL_RGB, GL11.GL_UNSIGNED_BYTE, buffer1);
+            GL41.glPixelStorei(GL41.GL_PACK_ALIGNMENT, 1);
+            GL41.glPixelStorei(GL41.GL_UNPACK_ALIGNMENT, 1);
+            GL41.glReadPixels(0, 0, width, height, GL41.GL_RGB, GL41.GL_UNSIGNED_BYTE, buffer1);
 
             for (int y = 0; y < height; y++) { // Flip image vertically
                 int index = y * width * 3;
diff --git a/game/client/src/main/java/net/minecraft/client/util/helper/Textures.java b/game/client/src/main/java/net/minecraft/client/util/helper/Textures.java
index 332168a12..347ccb144 100644
--- a/game/client/src/main/java/net/minecraft/client/util/helper/Textures.java
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/Textures.java
@@ -1,7 +1,6 @@
 package net.minecraft.client.util.helper;
 
 import static net.minecraft.client.util.helper.Buffer.*;
-import static org.lwjgl.opengl.GL11.*;
 
 import java.awt.Color;
 import java.awt.Graphics;
@@ -19,12 +18,12 @@ import com.mojang.logging.LogUtils;
 import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL12;
 
 import com.b100.utils.ImageUtils;
 
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.render.OpenGLHelper;
+import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
 
 public class Textures {
@@ -125,15 +124,15 @@ public class Textures {
 			Integer tex = textureList.getInt(i);
 
             LOGGER.debug("Tex: {}", tex);
-			
-			glBindTexture(GL_TEXTURE_2D, tex);
-			int maxLevel = glGetTexParameteri(GL_TEXTURE_2D, GL12.GL_TEXTURE_MAX_LEVEL);
+
+			GL41.glBindTexture(GL41.GL_TEXTURE_2D, tex);
+			int maxLevel = GL41.glGetTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_MAX_LEVEL);
 
             LOGGER.debug("Max Level: {}", maxLevel);
 			
 			for(int level = 0; level <= maxLevel; level++) {
-				int w = glGetTexLevelParameteri(GL_TEXTURE_2D, level, GL_TEXTURE_WIDTH);
-				int h = glGetTexLevelParameteri(GL_TEXTURE_2D, level, GL_TEXTURE_HEIGHT);
+				int w = GL41.glGetTexLevelParameteri(GL41.GL_TEXTURE_2D, level, GL41.GL_TEXTURE_WIDTH);
+				int h = GL41.glGetTexLevelParameteri(GL41.GL_TEXTURE_2D, level, GL41.GL_TEXTURE_HEIGHT);
 				
 				OpenGLHelper.checkError("dump check texture size");
 				
@@ -148,8 +147,8 @@ public class Textures {
 				ByteBuffer buffer = Buffer.buffer;
 				
 				buffer.position(0).limit(size);
-				glGetTexImage(GL_TEXTURE_2D, level, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
-				if(glGetError() == 0) {
+				GL41.glGetTexImage(GL41.GL_TEXTURE_2D, level, GL41.GL_RGBA, GL41.GL_UNSIGNED_BYTE, buffer);
+				if(GL41.glGetError() == 0) {
 					buffer.position(0);
 					ImageUtils.saveExternalImage(getImage(buffer, w, h, true, false), new File(folder, "tex"+tex+"-level"+level+".png"));
 					
@@ -183,9 +182,9 @@ public class Textures {
 	}
 	
 	public static BufferedImage getTextureAsImage(int texture, boolean alpha, int level, boolean mirrorVertical) {
-		glBindTexture(GL_TEXTURE_2D, texture);
-		int w = glGetTexLevelParameteri(GL_TEXTURE_2D, level, GL_TEXTURE_WIDTH);
-		int h = glGetTexLevelParameteri(GL_TEXTURE_2D, level, GL_TEXTURE_HEIGHT);
+		GL41.glBindTexture(GL41.GL_TEXTURE_2D, texture);
+		int w = GL41.glGetTexLevelParameteri(GL41.GL_TEXTURE_2D, level, GL41.GL_TEXTURE_WIDTH);
+		int h = GL41.glGetTexLevelParameteri(GL41.GL_TEXTURE_2D, level, GL41.GL_TEXTURE_HEIGHT);
 		
 		if(w == 0 || h == 0) return null;
 
@@ -193,8 +192,8 @@ public class Textures {
 		
 		Buffer.reset();
 		Buffer.checkBufferSize(w * h * 16);
-		
-		glGetTexImage(GL_TEXTURE_2D, level, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
+
+		GL41.glGetTexImage(GL41.GL_TEXTURE_2D, level, GL41.GL_RGBA, GL41.GL_UNSIGNED_BYTE, buffer);
 		buffer.position(0);
 		buffer.limit(buffer.capacity());
 		
diff --git a/game/client/src/main/resources/shaders/world.vsh b/game/client/src/main/resources/shaders/world.vsh
index ae25ef18c..e6abd030c 100644
--- a/game/client/src/main/resources/shaders/world.vsh
+++ b/game/client/src/main/resources/shaders/world.vsh
@@ -18,6 +18,7 @@ uniform vec4 lightSourceDiffuse1;
 uniform vec4 lightSourceDiffuse2;
 
 uniform mat4 model;
+uniform mat4 texture;
 
 layout (std140) uniform Matrices {
     mat4 projection;
@@ -30,7 +31,7 @@ void main() {
     vec4 p = vec4(aPos, 1);
     gl_Position = matrices.projection * matrices.view * model * p;
 
-    TexCoord = aUV;
+    TexCoord = (texture * vec4(aUV, 0.0f, 1.0f)).xy;
     Color = aColor;
     LightMapCoord = aLightmap;
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java
index 3f4badadd..a4381e965 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java
@@ -95,7 +95,7 @@ public class BlockLogicLeavesCherryFlowering extends BlockLogicLeavesCherry impl
             if(!world.isClientSide) {
                 if(world.getSeasonManager().getCurrentSeason() != Seasons.OVERWORLD_SPRING)
                     return true;
-                world.setBlockIdNotify(tilePos, setGrowthRate(meta, MAX_GROWTH_STATE));
+                world.setBlockDataNotify(tilePos, setGrowthRate(meta, MAX_GROWTH_STATE));
                 if (player == null || player.getGamemode().consumeBlocks()) {
                     itemStack.stackSize--;
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java b/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
index 072755551..5024b055a 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.entity;
 
+import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicSand;
 import net.minecraft.core.block.Blocks;
@@ -8,6 +9,7 @@ import net.minecraft.core.block.entity.TileEntityDispatcher;
 import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
@@ -27,30 +29,30 @@ public class EntityFallingBlock extends Entity
     public EntityFallingBlock(World world)
     {
         super(world);
-        carriedBlock = new CarriedBlock(this, Blocks.SAND, 0, null);
-        fallTime = 0;
+        this.carriedBlock = new CarriedBlock(this, Blocks.SAND, 0, null);
+        this.fallTime = 0;
         setSize(1F, 1F);
-        heightOffset = bbHeight / 2.0F;
+        this.heightOffset = this.bbHeight / 2.0F;
     }
 
     public EntityFallingBlock(World world, double x, double y, double z, int blockId, int blockMeta, @Nullable TileEntity tileEntity) {
         super(world);
-        fallTime = 0;
-        carriedBlock = new CarriedBlock(this, blockId, blockMeta, tileEntity);
+        this.fallTime = 0;
+        this.carriedBlock = new CarriedBlock(this, blockId, blockMeta, tileEntity);
         if (tileEntity != null) {
             tileEntity.worldObj = null;
-            tileEntity.carriedBlock = carriedBlock;
+            tileEntity.carriedBlock = this.carriedBlock;
         }
-        blocksBuilding = true;
+        this.blocksBuilding = true;
         setSize(1F, 1F);
-        heightOffset = bbHeight / 2.0F;
+        this.heightOffset = this.bbHeight / 2.0F;
         setPos(x, y, z);
-        xd = 0.0D;
-        yd = 0.0D;
-        zd = 0.0D;
-        xo = x;
-        yo = y;
-        zo = z;
+        this.xd = 0.0D;
+        this.yd = 0.0D;
+        this.zd = 0.0D;
+        this.xo = x;
+        this.yo = y;
+        this.zo = z;
     }
 
     @Override
@@ -67,55 +69,55 @@ public class EntityFallingBlock extends Entity
     @Override
 	public boolean isPickable()
     {
-        return !removed;
+        return !this.removed;
     }
 
     @Override
 	public void tick()
     {
-        if(carriedBlock.blockId == 0)
+        if(this.carriedBlock.blockId == 0)
         {
             remove();
             return;
         }
-        pushesThisTick = 0;
-        pushTime *= 0.98f;
-        if (pushTime < 0.05f || (pushTime < 0.25 && onGround)){
-            pushTime = 0;
+        this.pushesThisTick = 0;
+        this.pushTime *= 0.98f;
+        if (this.pushTime < 0.05f || (this.pushTime < 0.25 && this.onGround)){
+            this.pushTime = 0;
         }
-        if (isOnFire() && carriedBlock.blockId == Blocks.TNT.id()) {
+        if (isOnFire() && this.carriedBlock.blockId == Blocks.TNT.id()) {
             remove();
-            EntityPrimedTNT entityPrimedTNT = new EntityPrimedTNT(world, x, y, z);
+            EntityPrimedTNT entityPrimedTNT = new EntityPrimedTNT(this.world, this.x, this.y, this.z);
             entityPrimedTNT.xd = this.xd;
             entityPrimedTNT.yd = this.yd;
             entityPrimedTNT.zd = this.zd;
             entityPrimedTNT.pushTime = this.pushTime;
-            world.entityJoinedWorld(entityPrimedTNT);
+            this.world.entityJoinedWorld(entityPrimedTNT);
             return;
         }
-        xo = x;
-        yo = y;
-        zo = z;
-        if (pushTime < 0.01 && yd <= 0) {
-            fallTime++;
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        if (this.pushTime < 0.01 && this.yd <= 0) {
+            this.fallTime++;
         }
-        yd -= 0.04D;
-        move(xd, yd, zd);
-        xd *= 0.98D;
-        yd *= 0.98D;
-        zd *= 0.98D;
+        this.yd -= 0.04D;
+        move(this.xd, this.yd, this.zd);
+        this.xd *= 0.98D;
+        this.yd *= 0.98D;
+        this.zd *= 0.98D;
         int x = MathHelper.round(this.x - 0.5);
         int y = MathHelper.round(this.y);
         int z = MathHelper.round(this.z - 0.5);
-        if(world.getBlockId(x, y, z) == carriedBlock.blockId && !hasRemovedBlock)
+        if(this.world.getBlockId(x, y, z) == this.carriedBlock.blockId && !this.hasRemovedBlock)
         {
-            world.setBlockWithNotify(x, y, z, 0);
-            hasRemovedBlock = true;
+            this.world.setBlockWithNotify(x, y, z, 0);
+            this.hasRemovedBlock = true;
         }
-        if (onGround) {
-            Block<?> selfBlock = carriedBlock.block();
-            Block<?> blockBelow = world.getBlock(x, y - 1, z);
-            Block<?> blockAt = world.getBlock(x, y, z);
+        if (this.onGround) {
+            Block<?> selfBlock = this.carriedBlock.block();
+            Block<?> blockBelow = this.world.getBlock(x, y - 1, z);
+            Block<?> blockAt = this.world.getBlock(x, y, z);
             double friction = selfBlock.friction;
             if (BlockTags.OVERRIDE_FRICTION.appliesTo(blockAt)) {
                 friction *= blockAt.friction * 0.91f;
@@ -124,83 +126,139 @@ public class EntityFallingBlock extends Entity
             } else {
                 friction *= 0.98;
             }
-            xd *= friction;
-            zd *= friction;
-            yd *= -0.5D;
-            pushTime *= (float) friction;
+            this.xd *= friction;
+            this.zd *= friction;
+            this.yd *= -0.5D;
+            this.pushTime *= (float) friction;
         }
 
-        double v = Math.hypot(xd, zd);
+        double v = Math.hypot(this.xd, this.zd);
         if (v < 0.001 || isInWall()) {
-            if(onGround || isInWall())
+            if(this.onGround || isInWall())
             {
                 Entity rider = getPassenger();
                 ejectRider();
                 remove();
-                if((!world.canBlockBePlacedAt(carriedBlock.blockId, x, y, z, true, Side.TOP) || BlockLogicSand.canFallBelow(world, new TilePos(x, y - 1, z)) || !world.setBlock(x, y, z, carriedBlock.blockId)) && !world.isClientSide)
+                if((!this.world.canBlockBePlacedAt(this.carriedBlock.blockId, x, y, z, true, Side.TOP) || BlockLogicSand.canFallBelow(this.world, new TilePos(x, y - 1, z)) || !this.world.setBlock(x, y, z, this.carriedBlock.blockId)) && !this.world.isClientSide)
                 {
-                    if(hasRemovedBlock) {
+                    if(this.hasRemovedBlock) {
                         drop();
                     }
-                } else if (!world.isClientSide) {
-                    world.setBlockMetadata(x, y, z, carriedBlock.metadata);
-                    if (carriedBlock.entity != null) {
-                        TileEntity oldEnt = world.getTileEntity(x, y, z);
+                } else if (!this.world.isClientSide) {
+                    this.world.setBlockMetadata(x, y, z, this.carriedBlock.metadata);
+                    if (this.carriedBlock.entity != null) {
+                        TileEntity oldEnt = this.world.getTileEntity(x, y, z);
                         if (oldEnt != null) {
                             oldEnt.invalidate();
                         }
-                        carriedBlock.entity.validate();
-                        carriedBlock.entity.x = x;
-                        carriedBlock.entity.y = y;
-                        carriedBlock.entity.z = z;
-                        carriedBlock.entity.worldObj = world;
-                        carriedBlock.entity.carriedBlock = null;
-                        world.replaceBlockTileEntity(x, y, z, carriedBlock.entity);
+                        this.carriedBlock.entity.validate();
+                        this.carriedBlock.entity.x = x;
+                        this.carriedBlock.entity.y = y;
+                        this.carriedBlock.entity.z = z;
+                        this.carriedBlock.entity.worldObj = this.world;
+                        this.carriedBlock.entity.carriedBlock = null;
+                        this.world.replaceBlockTileEntity(x, y, z, this.carriedBlock.entity);
                     }
-                    world.notifyBlockChange(x, y, z, carriedBlock.blockId);
+                    this.world.notifyBlockChange(x, y, z, this.carriedBlock.blockId);
                 }
                 if (rider != null) {
-                    TileEntity te = world.getTileEntity(x, y, z);
+                    TileEntity te = this.world.getTileEntity(x, y, z);
                     if (te instanceof IVehicle) rider.startRiding((IVehicle) te);
                 }
-            } else if(fallTime > 600 && !world.isClientSide) {
-                if(hasRemovedBlock) {
+            } else if(this.fallTime > 600 && !this.world.isClientSide) {
+                if(this.hasRemovedBlock) {
                     drop();
                 }
                 ejectRider();
                 remove();
             }
 
-            carriedBlock.heldTick(world, this);
+            this.carriedBlock.heldTick(this.world, this);
         }
     }
 
     public void drop() {
-        Block<?> block = carriedBlock.block();
+        Block<?> block = this.carriedBlock.block();
         if (block != null) {
-            ItemStack[] drops = block.getBreakResult(world, EnumDropCause.SILK_TOUCH, carriedBlock.metadata, carriedBlock.entity);
+            ItemStack[] drops = block.getBreakResult(this.world, EnumDropCause.SILK_TOUCH, this.carriedBlock.metadata, this.carriedBlock.entity);
             if (drops != null && drops.length > 0) {
                 for (int i = 0; i < drops.length; i++) {
                     dropItem(drops[i], 0);
                 }
             }
         }
-        if (carriedBlock.entity != null) {
+        if (this.carriedBlock.entity != null) {
             int x = MathHelper.round(this.x - 0.5);
             int y = MathHelper.round(this.y);
             int z = MathHelper.round(this.z - 0.5);
-            carriedBlock.entity.dropContents(world, x, y, z);
+            this.carriedBlock.entity.dropContents(this.world, x, y, z);
         }
     }
 
+    @Override
+    public int calcLightmap(float partialTick) {
+        if (Global.accessor.isFullbrightEnabled()) return 15 << 20 | 15;
+        TilePos blockPos = new TilePos(this.x, this.y - this.heightOffset + this.ySlideOffset + this.bbHeight * 0.66D, this.z);
+
+        final int skylight;
+        final int blocklight;
+        if (this.world.getBlockLitInteriorSurface(blockPos) || this.world.getBlock(blockPos) == this.carriedBlock.block()) {
+            TilePos queryPos = new TilePos();
+
+            int bU = this.world.getSavedLightValue(LightLayer.Block, blockPos.up(queryPos));
+            final int bW = this.world.getSavedLightValue(LightLayer.Block, blockPos.west(queryPos));
+            final int bE = this.world.getSavedLightValue(LightLayer.Block, blockPos.east(queryPos));
+            final int bS = this.world.getSavedLightValue(LightLayer.Block, blockPos.south(queryPos));
+            final int bN = this.world.getSavedLightValue(LightLayer.Block, blockPos.north(queryPos));
+            if (bW > bU) {
+                bU = bW;
+            }
+            if (bE > bU) {
+                bU = bE;
+            }
+            if (bS > bU) {
+                bU = bS;
+            }
+            if (bN > bU) {
+                bU = bN;
+            }
+            blocklight = bU;
+
+            int sU = this.world.getSavedLightValue(LightLayer.Sky, blockPos.up(queryPos));
+            final int sW = this.world.getSavedLightValue(LightLayer.Sky, blockPos.west(queryPos));
+            final int sE = this.world.getSavedLightValue(LightLayer.Sky, blockPos.east(queryPos));
+            final int sS = this.world.getSavedLightValue(LightLayer.Sky, blockPos.south(queryPos));
+            final int sN = this.world.getSavedLightValue(LightLayer.Sky, blockPos.north(queryPos));
+            if (sW > sU) {
+                sU = sW;
+            }
+            if (sE > sU) {
+                sU = sE;
+            }
+            if (sS > sU) {
+                sU = sS;
+            }
+            if (sN > sU) {
+                sU = sN;
+            }
+            skylight = sU;
+
+        } else {
+            skylight = this.world.getSavedLightValue(LightLayer.Sky, blockPos);
+            blocklight = this.world.getSavedLightValue(LightLayer.Block, blockPos);
+        }
+
+        return this.world.getLightmapCoord(skylight, blocklight);
+    }
+
     @Override
     public void addAdditionalSaveData(@NotNull CompoundTag tag)
     {
-        tag.putShort("Tile", (short)carriedBlock.blockId);
-        tag.putShort("TileData", (short) carriedBlock.metadata);
-        if (carriedBlock.entity != null) {
+        tag.putShort("Tile", (short) this.carriedBlock.blockId);
+        tag.putShort("TileData", (short) this.carriedBlock.metadata);
+        if (this.carriedBlock.entity != null) {
             CompoundTag entityTag = new CompoundTag();
-            carriedBlock.entity.writeToNBT(entityTag);
+            this.carriedBlock.entity.writeToNBT(entityTag);
             tag.putCompound("TileEntity", entityTag);
         }
     }
@@ -208,7 +266,7 @@ public class EntityFallingBlock extends Entity
     @Override
 	public void readAdditionalSaveData(@NotNull CompoundTag tag)
     {
-        carriedBlock = new CarriedBlock(this,
+        this.carriedBlock = new CarriedBlock(this,
             tag.getShort("Tile") & 0x3fff,
             tag.getShort("TileData") & 0xff,
             tag.containsKey("TileEntity") ? TileEntityDispatcher.createAndLoadEntity(tag.getCompound("TileEntity")) : null);
